CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

GetBlockAttributeValue Method (ActiveX)

2023-1-4 09:53| 发布者: admin| 查看: 530| 评论: 0|来自: AutoCAD

摘要: 获取块内容中具有属性定义 ID 的属性值。

获取块内容中具有属性定义 ID 的属性值。

支持的平台:仅窗口

签名 - MLeader

工 务 局:

RetVal = object.GetBlockAttributeValue(attdefId)
对象

类型:MLeader

此方法适用的对象。

attdefID

访问:仅输入

类型:Long_PTR

属性定义 ID。

签名 - 表

工 务 局:

RetVal = object.GetBlockAttributeValue(row, col, attdefId)
对象

类型:桌子

此方法适用的对象。

访问:仅输入

类型:

表中的行。

山坳

访问:仅输入

类型:

表中的列。

attdefId

访问:仅输入

类型:Long_PTR

属性定义 ID。

返回值(RetVal)

类型:字符串

属性值。

言论

没有额外的评论。

例子

工 务 局:

Sub Example_Blockttribute()
    ' This example creates an MLeader object and gets and sets values for
    ' the block attribute type.

    Dim points(0 To 5) As Double

    points(0) = 0: points(1) = 4: points(2) = 0
    points(3) = 1.5: points(4) = 5: points(5) = 0

    Dim i As Long

    Dim oML As AcadMLeader
    Set oML = ThisDrawing.ModelSpace.AddMLeader(points, i)
    
    oML.ContentType = acBlockContent
    oML.ContentBlockType = acBlockBox

    Dim sBlock As String

    sBlock = oML.ContentBlockName

    Dim o As AcadEntity
    For Each o In ThisDrawing.Blocks(sBlock)
        If o.ObjectName = "AcDbAttributeDefinition" Then
            oML.SetBlockAttributeValue o.ObjectID, "123"
            MsgBox oML.GetBlockAttributeValue(o.ObjectID)
        End If
    Next o
    
    Update
    ZoomExtents

End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_BlockAttribute()
    ;; This example creates an MLeader object and gets and sets values for
    ;; the block attribute type.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
  
    (setq points (vlax-make-safearray vlax-vbDouble '(0 . 5)))
    (vlax-safearray-fill points '(0 4 0
                                  1.5 5 0
                                 )
    )
    (setq i 0)
  
    (setq modelSpace (vla-get-ModelSpace doc))  
    (setq oML (vla-AddMLeader modelSpace points i))
    
    (vla-put-ContentType oML acBlockContent)
    (vla-put-ContentBlockType oML acBlockBox)

    (setq sBlock (vla-get-ContentBlockName oML))

    (vlax-for o (vla-Item (vla-get-Blocks doc) sBlock)
        (if (= (vla-get-ObjectName o) "AcDbAttributeDefinition")
	           (progn
                (vla-SetBlockAttributeValue oML (vla-get-ObjectID o) "123")
                (alert (vla-GetBlockAttributeValue oML (vla-get-ObjectID o)))
	           )
        )
    )
  
    (vla-Update acadObj)
    (vla-ZoomExtents acadObj)
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-12 03:18

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部